package cn.jiguang.joperate.joperatedemo.ui.main;

import android.arch.lifecycle.Observer;
import android.arch.lifecycle.ViewModelProviders;
import android.os.Bundle;
import android.support.annotation.NonNull;
import android.support.annotation.Nullable;
import android.support.v4.app.Fragment;
import android.support.v7.widget.LinearLayoutManager;
import android.support.v7.widget.RecyclerView;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;

import org.json.JSONObject;

import java.util.Map;

import cn.jiguang.joperate.api.JOperateInterface;
import cn.jiguang.joperate.joperatedemo.R;
import cn.jiguang.joperate.joperatedemo.data.adapter.PresetAdapter;

public class PresetFragment extends Fragment implements View.OnClickListener {

    private static final String TAG = "PresetFragment";
    private MainViewModel mViewModel;
    PresetAdapter adapter;
    public static PresetFragment newInstance() {
        return new PresetFragment();
    }

    @Nullable
    @Override
    public View onCreateView(@NonNull LayoutInflater inflater, @Nullable ViewGroup container,
                             @Nullable Bundle savedInstanceState) {
        View view = inflater.inflate(R.layout.preset_fragment, container, false);
        view.findViewById(R.id.back).setOnClickListener(this);


        RecyclerView recyclerView = view.findViewById(R.id.recyclerView);
        LinearLayoutManager layoutManager = new LinearLayoutManager(getContext());
        layoutManager.setOrientation(LinearLayoutManager.VERTICAL);
        recyclerView.setLayoutManager(layoutManager);
        adapter = new PresetAdapter();
        recyclerView.setAdapter(adapter);
        return view;
    }

    @Override
    public void onActivityCreated(@Nullable Bundle savedInstanceState) {
        super.onActivityCreated(savedInstanceState);
        mViewModel = ViewModelProviders.of(getActivity()).get(MainViewModel.class);
        mViewModel.mMap.observe(this, new Observer<Map<String, Object>>() {
            @Override
            public void onChanged(@Nullable Map<String, Object> map) {
                for (String key : map.keySet()) {
                    if (MainViewModel.MAP_TYPE_ON_REFRESH.equals(key)) {
                        Log.d(TAG, "MAP_TYPE_ON_REFRESH:" );
                        peripheralProperty();
                    }
                }

            }
        });

        peripheralProperty();
    }

    private void peripheralProperty() {
        Log.d(TAG, "peripheralProperty:" );
        mViewModel.setRefreshing(true);
        JSONObject peripheralProperty = JOperateInterface.getInstance(getContext()).getPeripheralProperty();
        adapter.setData(peripheralProperty);
        adapter.notifyDataSetChanged();
        mViewModel.setRefreshing(false);
    }

    @Override
    public void onClick(View v) {
        switch (v.getId()){
            case R.id.back:
                Log.d(TAG,"onClick back");
                getFragmentManager().popBackStack();
                break;
        }
    }
}